# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
import warnings

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from sailpoint.v2024.models.scheduled_action_response_content_backup_options import ScheduledActionResponseContentBackupOptions
from typing import Optional, Set
from typing_extensions import Self

class ScheduledActionResponseContent(BaseModel):
    """
    Content details for the scheduled action.
    """ # noqa: E501
    name: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="Name of the scheduled action (maximum 50 characters).")
    backup_options: Optional[ScheduledActionResponseContentBackupOptions] = Field(default=None, alias="backupOptions")
    source_backup_id: Optional[StrictStr] = Field(default=None, description="ID of the source backup. Required for CREATE_DRAFT jobs only.", alias="sourceBackupId")
    source_tenant: Optional[StrictStr] = Field(default=None, description="Source tenant identifier. Required for CREATE_DRAFT jobs only.", alias="sourceTenant")
    draft_id: Optional[StrictStr] = Field(default=None, description="ID of the draft to be deployed. Required for CONFIG_DEPLOY_DRAFT jobs only.", alias="draftId")
    __properties: ClassVar[List[str]] = ["name", "backupOptions", "sourceBackupId", "sourceTenant", "draftId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ScheduledActionResponseContent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of backup_options
        if self.backup_options:
            _dict['backupOptions'] = self.backup_options.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ScheduledActionResponseContent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "backupOptions": ScheduledActionResponseContentBackupOptions.from_dict(obj["backupOptions"]) if obj.get("backupOptions") is not None else None,
            "sourceBackupId": obj.get("sourceBackupId"),
            "sourceTenant": obj.get("sourceTenant"),
            "draftId": obj.get("draftId")
        })
        return _obj


