# coding: utf-8

"""
    Identity Security Cloud V2025 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2025
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
import warnings

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from sailpoint.v2025.models.cluster_manual_upgrade_jobs_inner_managed_process_configuration import ClusterManualUpgradeJobsInnerManagedProcessConfiguration
from typing import Optional, Set
from typing_extensions import Self

class ClusterManualUpgradeJobsInner(BaseModel):
    """
    ClusterManualUpgradeJobsInner
    """ # noqa: E501
    uuid: StrictStr = Field(description="Unique identifier for the upgrade job.")
    cookbook: StrictStr = Field(description="Identifier for the cookbook used in the upgrade job.")
    state: StrictStr = Field(description="Current state of the upgrade job.")
    type: StrictStr = Field(description="The type of upgrade job (e.g., VA_UPGRADE).")
    target_id: StrictStr = Field(description="Unique identifier of the target for the upgrade job.", alias="targetId")
    managed_process_configuration: ClusterManualUpgradeJobsInnerManagedProcessConfiguration = Field(alias="managedProcessConfiguration")
    __properties: ClassVar[List[str]] = ["uuid", "cookbook", "state", "type", "targetId", "managedProcessConfiguration"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ClusterManualUpgradeJobsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of managed_process_configuration
        if self.managed_process_configuration:
            _dict['managedProcessConfiguration'] = self.managed_process_configuration.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ClusterManualUpgradeJobsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "uuid": obj.get("uuid"),
            "cookbook": obj.get("cookbook"),
            "state": obj.get("state"),
            "type": obj.get("type"),
            "targetId": obj.get("targetId"),
            "managedProcessConfiguration": ClusterManualUpgradeJobsInnerManagedProcessConfiguration.from_dict(obj["managedProcessConfiguration"]) if obj.get("managedProcessConfiguration") is not None else None
        })
        return _obj


