# coding: utf-8

"""
    Identity Security Cloud V2025 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2025
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
import warnings

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2025.models.scheduled_action_payload_content import ScheduledActionPayloadContent
from typing import Optional, Set
from typing_extensions import Self

class ScheduledActionPayload(BaseModel):
    """
    ScheduledActionPayload
    """ # noqa: E501
    job_type: StrictStr = Field(description="Type of the scheduled job.", alias="jobType")
    start_time: Optional[datetime] = Field(default=None, description="The time when this scheduled action should start. Optional.", alias="startTime")
    cron_string: Optional[StrictStr] = Field(default=None, description="Cron expression defining the schedule for this action. Optional for repeated events.", alias="cronString")
    time_zone_id: Optional[StrictStr] = Field(default=None, description="Time zone ID for interpreting the cron expression. Optional, will default to current time zone.", alias="timeZoneId")
    content: ScheduledActionPayloadContent
    __properties: ClassVar[List[str]] = ["jobType", "startTime", "cronString", "timeZoneId", "content"]

    @field_validator('job_type')
    def job_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['BACKUP', 'CREATE_DRAFT', 'CONFIG_DEPLOY_DRAFT']):
            warnings.warn(f"must be one of enum values ('BACKUP', 'CREATE_DRAFT', 'CONFIG_DEPLOY_DRAFT') unknown value: {value}")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ScheduledActionPayload from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of content
        if self.content:
            _dict['content'] = self.content.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ScheduledActionPayload from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "jobType": obj.get("jobType"),
            "startTime": obj.get("startTime"),
            "cronString": obj.get("cronString"),
            "timeZoneId": obj.get("timeZoneId"),
            "content": ScheduledActionPayloadContent.from_dict(obj["content"]) if obj.get("content") is not None else None
        })
        return _obj


